Wt: Wt::WMediaPlayer Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Member Functions | List of all members
Wt::WMediaPlayer Class Reference

A media player. More...

`#include <Wt/WMediaPlayer.h>`

Inheritance diagram for Wt::WMediaPlayer:
[legend]

## Public Types
typedef MediaEncoding | Encoding
| Typedef for enum Wt::MediaEncoding.
typedef MediaType | Type
| Typedef for enum Wt::MediaType.
typedef MediaPlayerButtonId | ButtonId
| Typedef for enum Wt::MediaPlayerButtonId.
typedef MediaPlayerProgressBarId | ProgressBarId
| Typedef for enum Wt::MediaPlayerProgressBarId.
typedef MediaPlayerTextId | TextId
| Typedef for enum Wt::MediaPlayerTextId.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WMediaPlayer (MediaType mediaType)
| Creates a new media player.
| ~WMediaPlayer ()
| Destructor.
void | setVideoSize (int width, int height)
| Sets the video size.
int | videoWidth () const
| Returns the video width.
int | videoHeight () const
| Returns the video height.
void | setControlsWidget (std::unique_ptr< WWidget > controls)
| Sets the user-interface controls widget.
WWidget * | controlsWidget () const
| Returns the user-interface controls widget.
void | setTitle (const WString &title)
| Sets the media title.
void | addSource (MediaEncoding encoding, const WLink &link)
| Adds a source.
WLink | getSource (MediaEncoding encoding) const
| Returns a source.
void | clearSources ()
| Clears all sources.
void | setButton (MediaPlayerButtonId id, WInteractWidget *btn)
| Binds a control button.
WInteractWidget * | button (MediaPlayerButtonId id) const
| Returns a control button.
void | setProgressBar (MediaPlayerProgressBarId id, WProgressBar *progressBar)
| Binds a control progress bar.
WProgressBar * | progressBar (MediaPlayerProgressBarId id) const
| Returns a control progress bar.
void | setText (MediaPlayerTextId id, WText *text)
| Sets a text place-holder widget.
WText * | text (MediaPlayerTextId id) const
| Returns a text place-holder widget.
void | pause ()
| Pauses the player.
void | play ()
| Start or resume playing.
void | stop ()
| Stops the player.
void | seek (double time)
| Seeks to a time.
void | setPlaybackRate (double rate)
| Sets the playback rate.
void | setVolume (double volume)
| Sets the volume.
double | volume () const
| Returns the volume.
void | mute (bool mute)
| Mutes or unmutes the playback volume.
bool | playing () const
| Returns whether the media is currently playing.
MediaReadyState | readyState () const
| Returns the current player state.
double | duration () const
| Returns the duration.
double | currentTime () const
| Returns the current playback time.
double | playbackRate () const
| Returns the current playback rate.
JSignal< double > & | timeUpdated ()
| Event that indicates a time update.
JSignal & | playbackStarted ()
| Event that indicates that playback started.
JSignal & | playbackPaused ()
| Event that indicates that playback paused.
JSignal & | ended ()
| Event that indicates that the video or audio has ended.
JSignal< double > & | volumeChanged ()
| Event that indicates that the volume has changed.
virtual void | refresh () override
| Refresh the widget.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A media player.

This widget implements a media player, suitable to play video or audio, and with a customizable user-interface.

To support cross-browser playing of video or audio content, you may need to provide the contents appropriately encoded. For audio, at least an MP3 or MP4 audio (M4A) encoding should be supplied, while for video the M4V encoding should be provided. Additional encodings are beneficial since they increase the chance that native HTML `<video>` or `<audio>` elements can be used (which may be hardware accelerated), instead of the flash player. See HTML5 browser media support.

You need to specify the encoding types you are going to use when instantiating the media player, since based on the chosen encodings, a particular suitable implementation will be used. Thus, you need to call addSource() immediately, but you may pass empty URLs if you do not yet want to load media.

The player provides a user-interface to control the playback which may be freely customized, and which is independent of the underlying media technology (HTML video or Flash player). The controls user-interface may be implemented as a Wt widget, where the controls (buttons, progress bars, and text widgets) are bound directly to the video player component (client-side).

This widget relies on a third-party JavaScript component jPlayer, which is distributed together with Wt.

The default user-interface can be themed using jPlayer themes. The theme is global (it applies to all media player instances), and is configured by loading a CSS stylesheet.

The following code creates a video using the default controls:

useStyleSheet(WApplication::relativeResourcesUrl() + "jPlayer/skin/jplayer.blue.monday.css");
auto player = std::make_unique<WMediaPlayer>(MediaType::Video);
player->addSource(MediaEncoding::M4V, "video.m4v");
player->addSource(MediaEncoding::OGV, "video.ogv");
player->addSource(MediaEncoding::PosterImage, "poster.png");
Wt::WApplication::relativeResourcesUrl
static std::string relativeResourcesUrl()
Returns the URL at which the resources are deployed.
Wt::MediaEncoding::M4V
@ M4V
Video: MP4 encoding (essential video format)
Wt::MediaEncoding::PosterImage
@ PosterImage
The poster image (e.g. JPG/PNG) for a video.
Wt::MediaEncoding::OGV
@ OGV
Video: OGG encoding.
Wt::MediaType::Video
@ Video
Defines a video player.

Alternatively, a custom widget may be set which implements the controls, using setControlsWidget(). In this case, you should add to this widget the buttons, text place holders, and progress bars and bind them to the media player using the setButton(), setText() and setProgressBar() methods. The controls widget is integrated in the media player, and this has as unique benefit (for a video player) that they may also be shown when the video player is maximized.

Finally, you may want to control the media player only through widgets external to the media player. This may be configured by setting `0` as controlsWidget. In this case however, full screen mode should not be used since there is no way to restore the original size.

## Constructor & Destructor Documentation

## ◆ WMediaPlayer()

Wt::WMediaPlayer::WMediaPlayer | ( | MediaType | mediaType | ) |

Creates a new media player.

The player is instantiated with default controls.

See also
  setControlsWidget()

## Member Function Documentation

## ◆ addSource()

void Wt::WMediaPlayer::addSource | ( | MediaEncoding | encoding,
|  | const WLink & | link )

Adds a source.

Adds a media source. The source may be specified as a URL or as a dynamic resource.

You may pass a null `link` if you want to indicate the media types you will use (later) without already loading data.

## ◆ button()

WInteractWidget * Wt::WMediaPlayer::button | ( | MediaPlayerButtonId | id | ) | const

Returns a control button.

See also
  setButton()

## ◆ clearSources()

void Wt::WMediaPlayer::clearSources | ( |  | ) |

Clears all sources.

See also
  addSource()

## ◆ controlsWidget()

WWidget * Wt::WMediaPlayer::controlsWidget | ( |  | ) | const

Returns the user-interface controls widget.

See also
  setControlsWidget()

## ◆ currentTime()

double Wt::WMediaPlayer::currentTime | ( |  | ) | const

Returns the current playback time.

Returns the current playback time, expressed in seconds.

See also
  seek()

## ◆ duration()

double Wt::WMediaPlayer::duration | ( |  | ) | const

Returns the duration.

The duration may be reported as 0 if the player has not yet loaded the media to determine the duration. Otherwise the duration is the duration of the loaded media, expressed in seconds.

See also
  readyState(), currentTime()

## ◆ getSource()

WLink Wt::WMediaPlayer::getSource | ( | MediaEncoding | encoding | ) | const

Returns a source.

Returns the media source for the given `encoding`, which must have previously been added using addSource().

## ◆ mute()

void Wt::WMediaPlayer::mute | ( | bool | mute | ) |

Mutes or unmutes the playback volume.

See also
  setVolume()

## ◆ pause()

void Wt::WMediaPlayer::pause | ( |  | ) |

Pauses the player.

See also
  play()

## ◆ play()

void Wt::WMediaPlayer::play | ( |  | ) |

Start or resume playing.

The player starts or resumes playing at the current time.

See also
  seek()

## ◆ playbackPaused()

JSignal & Wt::WMediaPlayer::playbackPaused | ( |  | ) |

Event that indicates that playback paused.

The event is fired when playback has been paused.

## ◆ playbackRate()

double Wt::WMediaPlayer::playbackRate | ( |  | ) | const

Returns the current playback rate.

See also
  setPlaybackRate()

## ◆ playbackStarted()

JSignal & Wt::WMediaPlayer::playbackStarted | ( |  | ) |

Event that indicates that playback started.

The event is fired when playback has started (or is being continued).

## ◆ playing()

bool Wt::WMediaPlayer::playing | ( |  | ) | const

Returns whether the media is currently playing.

See also
  play()

## ◆ progressBar()

WProgressBar * Wt::WMediaPlayer::progressBar | ( | MediaPlayerProgressBarId | id | ) | const

Returns a control progress bar.

See also
  setProgressBar()

## ◆ readyState()

MediaReadyState Wt::WMediaPlayer::readyState | ( |  | ) | const

Returns the current player state.

The state reflects in how far the media player has loaded the media, and has determined its characteristics.

## ◆ refresh()

virtual void Wt::WMediaPlayer::refresh | ( |  | ) |
| overridevirtual

Refresh the widget.

The refresh method is invoked when the locale is changed using WApplication::setLocale() or when the user hit the refresh button.

The widget must actualize its contents in response.

Note
  This does not rerender the widget! Calling refresh() usually does not have any effect (unless you've reimplemented refresh() to attach to it an effect).

Reimplemented from Wt::WCompositeWidget.

## ◆ render()

virtual void Wt::WMediaPlayer::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

## ◆ seek()

void Wt::WMediaPlayer::seek | ( | double | time | ) |

Seeks to a time.

If possible, the player sets the current time to the indicated `time` (expressed in seconds).

Note
  It may be the case that this only works after the player has already loaded the media.

## ◆ setButton()

void Wt::WMediaPlayer::setButton | ( | MediaPlayerButtonId | id,
|  | WInteractWidget * | btn )

Binds a control button.

A control button is typically implemented as a WAnchor or a WPushButton (although any WInteractWidget can work).

You should use this method in conjunction with setControlsWidget() to bind buttons in a custom control interface to media player functions.

The default control widget implements all buttons using a WAnchor.

## ◆ setControlsWidget()

void Wt::WMediaPlayer::setControlsWidget | ( | std::unique_ptr< WWidget > | controls | ) |

Sets the user-interface controls widget.

This sets a widget that contains the controls (buttons, text widgets, etc...) to allow the user to control the player.

Widgets that implement the buttons, bars, and text holders should be bound to the player using setButton(), setText() and setProgressBar() calls.

Setting a `0` widget will result in a player without controls. For an audio player this has the effect of being entirely invisible.

The default controls widget is a widget that can be styled using a jPlayer CSS theme.

## ◆ setPlaybackRate()

void Wt::WMediaPlayer::setPlaybackRate | ( | double | rate | ) |

Sets the playback rate.

This modifies the playback rate, expressed as a ratio of the normal (natural) playback rate.

The default value is 1.0

Note
  Not all browsers support this function.

## ◆ setProgressBar()

void Wt::WMediaPlayer::setProgressBar | ( | MediaPlayerProgressBarId | id,
|  | WProgressBar * | progressBar )

Binds a control progress bar.

The progress bar for the MediaPlayerProgressBarId::Time indication should be contained in a WContainerWidget which bounds the width of the progress bar, rather than setting a width on the progress bar. This is because the progress bar may, in some cases, also be used to indicate which part of the media can be seeked, and for this its width is being manipulated.

You should use this method in conjunction with setControlsWidget() to bind progress bars in a custom control interface to media player functions.

## ◆ setText()

void Wt::WMediaPlayer::setText | ( | MediaPlayerTextId | id,
|  | WText * | text )

Sets a text place-holder widget.

This binds the widget that displays text such as current time and total duration of the loaded media.

You should use this method in conjunction with setControlsWidget() to bind progress bars in a custom control interface to media player functions.

## ◆ setTitle()

void Wt::WMediaPlayer::setTitle | ( | const WString & | title | ) |

Sets the media title.

See also
  MediaPlayerTextId::Title

## ◆ setVideoSize()

void Wt::WMediaPlayer::setVideoSize | ( | int | width,
|  | int | height )

Sets the video size.

This sets the size for the video. The actual size of the media player may be slightly larger, if the controlWidget take additional space (i.e. is not overlayed on top of the video).

CSS Themes for the default jPlayer controls support two formats (480 x 270 and 640 x 360).

The default video size is 480 x 270.

## ◆ setVolume()

void Wt::WMediaPlayer::setVolume | ( | double | volume | ) |

Sets the volume.

This modifies the volume, which must be a number between 0 and 1.0.

The default value is 0.8

## ◆ stop()

void Wt::WMediaPlayer::stop | ( |  | ) |

Stops the player.

See also
  play()

## ◆ text()

WText * Wt::WMediaPlayer::text | ( | MediaPlayerTextId | id | ) | const

Returns a text place-holder widget.

See also
  setText()

## ◆ timeUpdated()

JSignal< double > & Wt::WMediaPlayer::timeUpdated | ( |  | ) |

Event that indicates a time update.

The event indicates that the currentTime() has changed.

## ◆ videoHeight()

int Wt::WMediaPlayer::videoHeight | ( |  | ) | const

Returns the video height.

See also
  setVideoSize()

## ◆ videoWidth()

int Wt::WMediaPlayer::videoWidth | ( |  | ) | const

Returns the video width.

See also
  setVideoSize()

## ◆ volume()

double Wt::WMediaPlayer::volume | ( |  | ) | const

Returns the volume.

See also
  setVolume()